bindings = {}

--[[here's the full key name list; copy exactly as written

a
b
c
d
e
f
g
h
i
j
k
l
m
n
o
p
q
r
s
t
u
v
w
x
y
z

1
2
3
4
5
6
7
8
9
0

-
=
[
]
\
#
;
'
`
,
.
/
\

space
return
tab
escape

right
left
down
up

backspace
insert
delete

keypad_/
keypad_*
keypad_-
keypad_+
keypad_enter
keypad_1
keypad_2
keypad_3
keypad_4
keypad_5
keypad_6
keypad_7
keypad_8
keypad_9
keypad_0
keypad_.

left_ctrl
right_ctrl
left_shift
right_shift
left_alt
right_alt

printscreen
capslock
scrolllock
numlock

home
end
pageup
pagedown

f1
f2
f3
f4
f5
f6
f7
f8
f9
f10
f11
f12

mouse_left
mouse_right
mouse_middle
mouse_extra_1
mouse_extra_2

]]

--[[gamepad button list; [*] states the gamepad number; non-standard gamepads might be supported but extra buttons will not be listed here - check naming during rebinding

[*]gpd_y
[*]gpd_x
[*]gpd_a
[*]gpd_b

[*]gpd_r1
[*]gpd_r2
[*]gpd_r3
[*]gpd_l1
[*]gpd_l2
[*]gpd_l3

[*]gpd_right
[*]gpd_left
[*]gpd_down
[*]gpd_up

[*]gpd_select
[*]gpd_start

[*]gpd_btn_lh_+
[*]gpd_btn_lh_-
[*]gpd_btn_lv_+
[*]gpd_btn_lv_-
[*]gpd_btn_rh_+
[*]gpd_btn_rh_-
[*]gpd_btn_rv_+
[*]gpd_btn_rv_-

]]

bindings["mnee"] = {
	aa_menu = { --[ACTUAL BINDING ID] "aa_" is needed to maintain alphabetical order, since that's how this table is being sorted
		name = "Open M-nee", --[DISPLAYED NAME]
		desc = "Will open this menu.", --[DISPLAYED DESCRIPTION]
		keys = { --[DEFAULT BINDING KEYS]
			left_ctrl = 1, --number is just so the thing won't be nil
			m = 1,
		},
	},
	
	ab_off = {
		name = "Disable M-nee",
		desc = "Will disable all the custom inputs.",
		keys = {
			left_ctrl = 1,
		},
	},
	
	ac_pfl_chng = {
		name = "Change Profile",
		desc = "Cycle through independed binding profiles.",
		keys = {
			left_ctrl = 1,
		},
	},
}

bindings.mnee.ab_off.keys["keypad_-"] = 1 --"-" is actually a special symbol in lua, so shielding in form of a "" is required
bindings.mnee.ac_pfl_chng.keys["keypad_+"] = 1

--[[gamepad axis list; [*] states the gamepad number; non-standard gamepads might be supported but extra buttons will not be listed here - check naming after rebinding

[*]gpd_axis_lh
[*]gpd_axis_lv
[*]gpd_axis_rh
[*]gpd_axis_rv

bindings["example"] = {
	aa_stuff_1 = {
		is_locked = true,
		name = "Check This Out",
		desc = "You can have either proper analog input or a pair of absolute buttons. This one is generic.",
		keys = { "is_axis", "1gpd_axis_lh", },
	},
	aa_stuff_2 = {
		name = "Behold the Ultimate Power of Complete Input",
		desc = "And this one is extra fancy.",
		keys = { "is_axis", "keypad_+", "keypad_-", },
	},
}

]]